#define FREQUENT_LETTERS_AMOUNT 27

struct frequency_t {
	unsigned char letter;
	unsigned long frequency;
	unsigned long score;
};

struct frequency_set {
	static const unsigned Size = FREQUENT_LETTERS_AMOUNT;

	frequency_t frequencies[FREQUENT_LETTERS_AMOUNT];

	frequency_set()
	 {
		// Most frequent letters in english "etaoinshr",
		frequencies[0].letter='e';
		frequencies[0].frequency=12702;
		frequencies[0].score=0;

		frequencies[1].letter='t';
		frequencies[1].frequency=9056;
		frequencies[1].score=0;

		frequencies[2].letter='a';
		frequencies[2].frequency=8167;
		frequencies[2].score=0;

		frequencies[3].letter='o';
		frequencies[3].frequency=7507;
		frequencies[3].score=0;

		frequencies[4].letter='i';
		frequencies[4].frequency=6966;
		frequencies[4].score=0;

		frequencies[5].letter='n';
		frequencies[5].frequency=6749;
		frequencies[5].score=0;

		frequencies[6].letter='s';
		frequencies[6].frequency=6327;
		frequencies[6].score=0;

		frequencies[7].letter='h';
		frequencies[7].frequency=6094;
		frequencies[7].score=0;

		frequencies[8].letter='r';
		frequencies[8].frequency=5987;
		frequencies[8].score=0;

		frequencies[9].letter='d';
		frequencies[9].frequency=4253;
		frequencies[9].score=0;

		frequencies[10].letter='l';
		frequencies[10].frequency=4025;
		frequencies[10].score=0;

		frequencies[11].letter='c';
		frequencies[11].frequency=2782;
		frequencies[11].score=0;

		frequencies[12].letter='u';
		frequencies[12].frequency=2758;
		frequencies[12].score=0;

		frequencies[13].letter='m';
		frequencies[13].frequency=2406;
		frequencies[13].score=0;

		frequencies[14].letter='w';
		frequencies[14].frequency=2361;
		frequencies[14].score=0;

		frequencies[15].letter='f';
		frequencies[15].frequency=2228;
		frequencies[15].score=0;

		frequencies[16].letter='g';
		frequencies[16].frequency=2015;
		frequencies[16].score=0;

		frequencies[17].letter='y';
		frequencies[17].frequency=1974;
		frequencies[17].score=0;

		frequencies[18].letter='p';
		frequencies[18].frequency=1929;
		frequencies[18].score=0;

		frequencies[19].letter='b';
		frequencies[19].frequency=1492;
		frequencies[19].score=0;

		frequencies[20].letter='v';
		frequencies[20].frequency=978;
		frequencies[20].score=0;

		frequencies[21].letter='k';
		frequencies[21].frequency=772;
		frequencies[21].score=0;

		frequencies[22].letter='j';
		frequencies[22].frequency=153;
		frequencies[22].score=0;

		frequencies[23].letter='x';
		frequencies[23].frequency=150;
		frequencies[23].score=0;

		frequencies[24].letter='q';
		frequencies[24].frequency=95;
		frequencies[24].score=0;

		frequencies[25].letter='z';
		frequencies[25].frequency=74;
		frequencies[25].score=0;

// everything that's not alphabet

		frequencies[26].letter=' ';
		frequencies[26].frequency=12703; // 'e' + 1
		frequencies[26].score=0;
	}
	const frequency_t& operator[](const unsigned idx) {
		return frequencies[idx];
	}
};


double get_frequency(char c);
void xor_char_finder(const unsigned char* const p_ciphertext_xor, struct frequency_t& o_frequency, unsigned ciphertext_len);
int crack_repeted_xor(const char* const i_hex_string, unsigned char* o_buf, const unsigned i_min_block = 3,  const unsigned i_max_block = 40);
unsigned long long frequency_analysis(const unsigned char* i_text, const unsigned i_len);
int find_best_keysize(const char* i_hex_bytes, const unsigned i_len, const int i_min_keysize = 2, const int i_max_keysize = 40);